
/*
chrome.runtime.onInstalled.addListener(() => {



	if (details.reason === chrome.runtime.OnInstalledReason.INSTALL) {
	    chrome.runtime.setUninstallURL('https://example.com/extension-survey');
	  }
})

*/





chrome.runtime.onInstalled.addListener(details => {

  if (details.reason === chrome.runtime.OnInstalledReason.INSTALL) {
    	chrome.runtime.setUninstallURL('https://forms.gle/rPf3zUnVBsPohPei6');
  }

	chrome.tabs.create({
		url: 'https://pickyassist.com/en/whatsapp-google-extension?i=true',
		active: true
	})


	//chrome.storage.sync.set({'user': '' });

	chrome.storage.sync.set({'capps': ['tel'] });

	chrome.storage.sync.get(['shortcuts','Quick_Access_Position','widget_width','Quick_Access_Button'], function(work) {

		if( !work.shortcuts ){
			var shortcuts = {
				'contact' : 'c',
				'tb' : 't',
				'mini' : 'm',
				'toggle' : 'z'
			}


			chrome.storage.sync.set({'shortcuts': shortcuts });
		}

		if( !work.Quick_Access_Position ){

			chrome.storage.sync.set({'Quick_Access_Position': 5 });
		}

		if( !work.widget_width ){

			chrome.storage.sync.set({'widget_width': 2 });
		}

		if( !work.Quick_Access_Button ){

			chrome.storage.sync.set({'Quick_Access_Button': true });
		}

	})

});


chrome.runtime.onMessage.addListener( function (request, sender, sendResponse,qq) {



	var Call_Apps = {"tel": "System Default" ,"skype":"Skype" , "zoiper":"Zoiper", "facetime-audio":"Apple Facetime", "rcmobile":"Ring Central"}

	sendResponse({farewell: "goodbye"});

	chrome.contextMenus.removeAll();

	var sel = "%s";// request.data.replace(/\D/g,'').toString();
	var sel_id = '';



	chrome.storage.sync.get(['ccodes','template','d_temp','temp_names','connectors','connector_names','capps','mini_apps','mini_app_names'], function(work) {


		//console.log("NAMES :",work.temp_names);

		if( !work.temp_names)
			work.temp_names = {}

		if( !work.connector_names)
			work.connector_names = {}

		if( !work.mini_app_names)
			work.mini_app_names = {}

		if( !work.ccodes)
			work.ccodes = '';

		const temps_keys = Object.keys(work.temp_names).reverse();
		const conn_temps_keys = Object.keys(work.connector_names).reverse();
		const mini_temps_keys = Object.keys(work.mini_app_names).reverse();

		chrome.contextMenus.create({
			id: 'connector',
			title: "Picky Connector", 
			contexts:[ "selection" ]
		});

		chrome.contextMenus.create({
			id: 'miniapp',
			title: "Mini App", 
			contexts:[ "selection" ]
		});

		chrome.contextMenus.create({
			id: 'picky',
			title: "Picky TeamBox", 
			contexts:[ "selection" ]
		});

		chrome.contextMenus.create({
			id: 'wweb',
			title: "Whatsapp Web", 
			contexts:[ "selection" ]
		});

		chrome.contextMenus.create({
			id: 'wdesk',
			title: "Whatsapp Desktop", 
			contexts:[ "selection" ]
		});	

		chrome.contextMenus.create({
			id: 'call',
			title: "Call", 
			contexts:[ "selection" ]
		});

		chrome.contextMenus.create({
			id: 'sms',
			title: "SMS", 
			contexts:[ "selection" ]
		});



			chrome.contextMenus.create({
				parentId: "connector",
				id: 'connector_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "miniapp",
				id: 'miniapp_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "picky",
				id: 'picky_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "wweb",
				id: 'wweb_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "wdesk",
				id: 'wdesk_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "call",
				id: 'call_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "sms",
				id: 'sms_'+sel_id,
				title: sel, 
				contexts:[ "selection" ]
			});



			for(var j in work.capps) {


				chrome.contextMenus.create({
					parentId: 'call_'+sel_id,
					id: 'call_'+sel_id+'_'+work.capps[j],
					title: Call_Apps[work.capps[j]], 
					contexts:[ "selection" ]
				});


			}

			//for(var j in work.temp_names) {
			for(var j in temps_keys) {


				//console.log("JJJ : ",work.temp_names[j]);

				chrome.contextMenus.create({
					parentId: 'picky_'+sel_id,
					id: 'picky_'+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});

				chrome.contextMenus.create({
					parentId: 'wweb_'+sel_id,
					id: 'wweb_'+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});

				chrome.contextMenus.create({
					parentId: 'wdesk_'+sel_id,
					id: 'wdesk_'+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});

				chrome.contextMenus.create({
					parentId: 'sms_'+sel_id,
					id: 'sms_'+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});


			}


			for(var j in conn_temps_keys) {



				chrome.contextMenus.create({
					parentId: 'connector_'+sel_id,
					id: 'connector_'+sel_id+'_'+conn_temps_keys[j],
					title: work.connector_names[conn_temps_keys[j]], 
					contexts:[ "selection" ]
				});

			}

			for(var j in mini_temps_keys) {



				chrome.contextMenus.create({
					parentId: 'miniapp_'+sel_id,
					id: 'miniapp_'+sel_id+'_'+mini_temps_keys[j],
					title: work.mini_app_names[mini_temps_keys[j]], 
					contexts:[ "selection" ]
				});

			}



		var ccodes = work.ccodes.split(',');
		for (var i = 0; i < ccodes.length; i++) {
				
				if( ccodes[i].length == 0)
					continue;
			var code = ccodes[i].toString();

			chrome.contextMenus.create({
				parentId: "connector",
				id: 'connector_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "miniapp",
				id: 'miniapp_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "picky",
				id: 'picky_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "wweb",
				id: 'wweb_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "wdesk",
				id: 'wdesk_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});

			chrome.contextMenus.create({
				parentId: "call",
				id: 'call_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});			


			chrome.contextMenus.create({
				parentId: "sms",
				id: 'sms_'+code+sel_id,
				title: code+" "+sel, 
				contexts:[ "selection" ]
			});



			for(var j in work.capps) {


				chrome.contextMenus.create({
					parentId: 'call_'+code+sel_id,
					id: 'call_'+code+sel_id+'_'+work.capps[j],
					title: Call_Apps[work.capps[j]], 
					contexts:[ "selection" ]
				});


			}


			for(var j in temps_keys) {


				//console.log("JJJ : ",work.temp_names[j]);

				chrome.contextMenus.create({
					parentId: 'picky_'+code+sel_id,
					id: 'picky_'+code+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});

				chrome.contextMenus.create({
					parentId: 'wweb_'+code+sel_id,
					id: 'wweb_'+code+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});

				chrome.contextMenus.create({
					parentId: 'wdesk_'+code+sel_id,
					id: 'wdesk_'+code+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});

				chrome.contextMenus.create({
					parentId: 'sms_'+code+sel_id,
					id: 'sms_'+code+sel_id+'_'+temps_keys[j],
					title: work.temp_names[temps_keys[j]], 
					contexts:[ "selection" ]
				});


			}

			for(var j in conn_temps_keys) {



				chrome.contextMenus.create({
					parentId: 'connector_'+code+sel_id,
					id: 'connector_'+code+sel_id+'_'+conn_temps_keys[j],
					title: work.connector_names[conn_temps_keys[j]], 
					contexts:[ "selection" ]
				});

			}

			for(var j in mini_temps_keys) {



				chrome.contextMenus.create({
					parentId: 'miniapp_'+code+sel_id,
					id: 'miniapp_'+code+sel_id+'_'+mini_temps_keys[j],
					title: work.mini_app_names[mini_temps_keys[j]], 
					contexts:[ "selection" ]
				});

			}



		}


		//return true;

	})





});






chrome.contextMenus.onClicked.addListener( ( info, tab ) => {



	//if ( 'notify' === info.menuItemId ) {
		//console.log(info);
	console.log( info.selectionText + "\n" + info.menuItemId );

	//return true;

	chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
		  chrome.tabs.sendMessage(tabs[0].id, {data: info.menuItemId, url: info.pageUrl , text: info.selectionText }, function(response) {
		    //console.log(response.farewell);
		  });
	});

} );
